/*************************************************************10.12.2001*/
/* ran_mt: wrapper for the Mersenne twister which produces random	*/
/*	   numbers in the range [0; 1]					*/
/************************************************************************/
#include <mathC.h>
#include <random>

using namespace std;


double ran_mt() noexcept {
  static bool init = false;
  static std::mt19937_64 mt_generator(0);
  static std::uniform_real_distribution<double> distr(0.0, 1.0);

  if (!init) {
    std::random_device rd;
    mt_generator.seed(rd());
    init = true;
  }
  return distr(mt_generator);
}
