/*************************************************************09.10.2015*/
/* ran_seed: generate a seed for pseudo-random generators		*/
/*	     by using the kernel device /dev/urandom or, if this fails,	*/
/*	     the system clock						*/
/*======================================================================*/
/* RESULT		(o)  random (positive) 32-bit integer		*/
/************************************************************************/
#include <time.h>
#include <mathC.h>

using namespace std;


int ran_seed() noexcept {
  int i;
  FILE *fp;

  do {
    if ((fp = fopen("/dev/urandom", "r")) != NULL) {
      fread(&i, sizeof (int), 1, fp);	// query kernel random device
      i = abs(i);
      fclose(fp);
    }
    else
      i = time(NULL);			// get seconds after 1900
    if (i % 2 == 0) i--;		// avoid even numbers
    if (i % 3 == 0) i -= 2;
  } while (i <= 40);			// avoid too small numbers
  return i;
}
