/************************************************************24.05.02018*/
/* ran_sequence: generate a random sequence of integers in the range	*/
/*		 [0; n-1] (useful for shuffling arrays)			*/
/*									*/
/* NOTE: This subroutine requires 1 random number only. This saves CPU	*/
/* time, but might cause trouble if n is of the order of 2^b, where b 	*/
/* is the number of bits which the underlying random number generator	*/
/* reliably randomizes.							*/
/*======================================================================*/
/* n		(i)  length of the desired sequence
   RESULT	(o)  vector of randomly arranged integers		*/
/************************************************************************/
#include <mathC.h>

#define RANDOM		ran_shuffle()	// underlying random number generator

using namespace std;


Vector<int> ran_sequence(int n) noexcept {
  int i, j;
  Vector<int> s(n);
  double r = RANDOM;

  s.ramp(0, 1);
  for (i = n - 1; i >= 1; i--) {
    r *= i + 1;
    j = r;				// random integer in [0; i]
    if (j != i) swap(s[i], s[j]);
    r -= static_cast<double>(j);
  }
  return s;
}
