/*************************************************************10.12.2001*/
/* ran_stauffer: Stauffer's random number generator			*/
/*									*/
/* D. Stauffer, U. Cologne proposed a simple, but good multiplicative 	*/
/* algorithm:								*/
/* x[i+1] = (a*x[i]) mod m						*/
/* with: a = 16807, m = 2^31						*/
/************************************************************************/
#include <mathC.h>

using namespace std;


double ran_stauffer() noexcept {
  static int i, linit = 0;
  static double norm;

  if (linit == 0) {			// initialization
    linit = 1;
    i = ran_seed();
    norm = pow(2.0, -32.0);		// normalization constant
  }

  /* The next instruction works only if there is no overflow check. */
  i *= 16807;
  return 0.5 + i * norm;
}
