/************************************************************************/
/* test_m: test definitions of class Matrix				*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, j;
  Vector<double> a(3), b(2);
  Matrix<double> u(2, 3), v(2, 3), w(2, 2);

  printf("a dimension: %d\n", a.size());
  printf("u dimensions: %d x %d\n", u.rows(), u.cols());

  // preset u
  printf("u = (1.0):\n");
  u = 1.0;
  for (i = 0; i < u.rows(); i++) {
    u[i].print(stdout, " %f");
//  for (j = 0; j < u.cols(); j++) printf(" %f", u[i][j]);
    printf("\n");
  }

  // b = u * a
  printf("b = u * a\n");
  a.ramp(1.0, 1.0);
  b = u * a;
  b.print(stdout, " %f");
  printf("\n");

  // preset v with ramp vectors
  printf("v[i].ramp()\n");
  for (i = 0; i < v.rows(); i++) v[i].ramp(0.0, 1.0);
  for (i = 0; i < v.rows(); i++) {
    v[i].print(stdout, " %f");
    printf("\n");
  }

  // w = u * transpose(v)
  printf("w = u * transpose(v)\n");
  w = u & v;
  for (i = 0; i < w.rows(); i++) {
    w[i].print(stdout, " %f");
    printf("\n");
  }

  return mth_GOOD;
}
