/************************************************************************/
/* test_mcx1: test multicomplex arithmetics				*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i;
  multicomplex a, b;
  double x00, x01, x10, x11, x,
    h = 1.0e-30;

  a.init(2);
  fprintf(stderr, "bicomplex (4 components):\n");
  scanf("%lf%lf%lf%lf", &x00, &x01, &x10, &x11);
  a.r_idx(0, x00);
  a.r_idx(1, x01);
  a.r_idx(2, x10);
  a.r_idx(3, x11);
  printf("a:      (%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
//  b.init(1);
  b = a;				// b implicitly initialized
  printf("b:      (%15.8e %15.8e %15.8e %15.8e)\n", b.r_idx(0),
  b.r_idx(1), b.r_idx(2), b.r_idx(3));
  a += a;				// increment
  printf("a += a: (%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  a *= 0.5;				// scale, restore input
  printf("a *= ½: (%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  b = pow(a, 2.0);			// test pow, exp, log
  printf("b = a²: (%15.8e %15.8e %15.8e %15.8e)\n", b.r_idx(0),
  b.r_idx(1), b.r_idx(2), b.r_idx(3));
  b /= a;
  printf("b / a:  (%15.8e %15.8e %15.8e %15.8e)\n", b.r_idx(0),
  b.r_idx(1), b.r_idx(2), b.r_idx(3));
  b = a * cb(nthrt(a, -3));
  printf("a 3r(a)³(%15.8e %15.8e %15.8e %15.8e)\n", b.r_idx(0),
  b.r_idx(1), b.r_idx(2), b.r_idx(3));
  b = log(a);
  printf("ln(a):  (%15.8e %15.8e %15.8e %15.8e)\n", b.r_idx(0),
  b.r_idx(1), b.r_idx(2), b.r_idx(3));
  a *= a;				// alternative method for square
  printf("a *= a: (%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
#if 1
  b = a;
  b /= a;
  printf("a / a:  (%15.8e %15.8e %15.8e %15.8e)\n", b.r_idx(0),
  b.r_idx(1), b.r_idx(2), b.r_idx(3));
#else
  a = log(b);
  printf("ln(b):  (%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  b = exp(a);
  printf("e^ln(b):(%15.8e %15.8e %15.8e %15.8e)\n", b.r_idx(0),
  b.r_idx(1), b.r_idx(2), b.r_idx(3));
#endif
  a = 0.0;				// set to double
  printf("a = 0:  (%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));

  fprintf(stderr, "coefficients of cubic polynomial f(x) [0 … 3]:\n");
  Vector<double> poly(4);
  poly.read(stdin, "%lf");
  fprintf(stderr, "argument:\n");
  scanf("%lf", &x);

  multicomplex a1, b1;			// 1st-order differentiation
  a1.init(1);
  b1.init(1);
  b1.r_idx(0, x);
  b1.r_idx(1, h);
  for (i = 2, a1 = poly[3]; i >= 0; i--) {
    a1 *= b1;
    a1 += poly[i];
  }
  printf("f(x+h): (%15.8e %15.8e)\n", a1.r_idx(0), a1.r_idx(1));
  printf("f'(x):   %15.8e\n", a1.r_idx(1) / h);
  a1 = exp(b1);
  printf("e^(x+h):(%15.8e %15.8e)\n", a1.r_idx(0), a1.r_idx(1));
  printf("exp'(x): %15.8e\n", a1.r_idx(1) / h);
  a1 = log(b1);
  printf("ln(x+h):(%15.8e %15.8e)\n", a1.r_idx(0), a1.r_idx(1));
  printf("ln'(x):  %15.8e\n", a1.r_idx(1) / h);
  a1 = pow(b1, 0.5);
  printf("2r(x+h):(%15.8e %15.8e)\n", a1.r_idx(0), a1.r_idx(1));
  printf("2r'(x):  %15.8e\n", a1.r_idx(1) / h);
  a1 = sqrt(b1);
  printf("2R(x+h):(%15.8e %15.8e)\n", a1.r_idx(0), a1.r_idx(1));
  printf("2R'(x):  %15.8e\n", a1.r_idx(1) / h);

  b.r_idx(0, x);			// 2nd-order differentiation
  b.r_idx(1, h);
  b.r_idx(2, h);
  b.r_idx(3, 0);
  for (i = 2, a = poly[3]; i >= 0; i--) {
    a *= b;
    a += poly[i];
  }
  printf("f(x+h): (%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  printf("f\"(x):   %15.8e\n", a.r_idx(3) / sq(h));
  a = exp(b);
  printf("e^(x+h):(%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  printf("exp\"(x): %15.8e\n", a.r_idx(3) / sq(h));
  a = log(b);
  printf("ln(x+h):(%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  printf("ln\"(x):  %15.8e\n", a.r_idx(3) / sq(h));
  a = exp(a);
  printf("e^ln(.):(%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  a = pow(b, 0.5);
  printf("2r(x+h):(%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  printf("2r\"(x):  %15.8e\n", a.r_idx(3) / sq(h));
  a = sqrt(b);
  printf("2R(x+h):(%15.8e %15.8e %15.8e %15.8e)\n", a.r_idx(0),
  a.r_idx(1), a.r_idx(2), a.r_idx(3));
  printf("2R\"(x):  %15.8e\n", a.r_idx(3) / sq(h));

  multicomplex b3, a3;			// 3rd-order differentiation
  a3.init(3);
  b3.init(3);
  b3 = 0.0;
  b3.r_idx(0, x);
  b3.r_idx(1, h);
  b3.r_idx(2, h);
  b3.r_idx(4, h);
  printf("x+h:    (%15.8e %15.8e %15.8e %15.8e\n", b3.r_idx(0),
  b3.r_idx(1), b3.r_idx(2), b3.r_idx(3));
  printf("         %15.8e %15.8e %15.8e %15.8e)\n", b3.r_idx(4),
  b3.r_idx(5), b3.r_idx(6), b3.r_idx(7));
  for (i = 2, a3 = poly[3]; i >= 0; i--) {
    a3 *= b3;
    a3 += poly[i];
  }
  printf("f\"'(x):  %15.8e\n", a3.r_idx(7) / cb(h));
  a3 = exp(b3);
  printf("exp\"'(x):%15.8e\n", a3.r_idx(7) / cb(h));
  a3 = log(b3);
  printf("ln(x+h):(%15.8e %15.8e %15.8e %15.8e\n", a3.r_idx(0),
  a3.r_idx(1), a3.r_idx(2), a3.r_idx(3));
  printf("         %15.8e %15.8e %15.8e %15.8e)\n", a3.r_idx(4),
  a3.r_idx(5), a3.r_idx(6), a3.r_idx(7));
  printf("ln\"'(x): %15.8e\n", a3.r_idx(7) / cb(h));
  a3 = exp(log(b3));
  printf("e^ln(x):(%15.8e %15.8e %15.8e %15.8e\n", a3.r_idx(0),
  a3.r_idx(1), a3.r_idx(2), a3.r_idx(3));
  printf("         %15.8e %15.8e %15.8e %15.8e)\n", a3.r_idx(4),
  a3.r_idx(5), a3.r_idx(6), a3.r_idx(7));
  a3 = pow(b3, 0.5);
  printf("2r\"'(x): %15.8e\n", a3.r_idx(7) / cb(h));
  a3 = sqrt(b3);
  printf("2R\"'(x): %15.8e\n", a3.r_idx(7) / cb(h));
  return mth_GOOD;
}
