/************************************************************************/
/* test_cy1: test differentiation subroutine diff_cauchy_all		*/
/* (calculation of derivatives of exp(-x1^2 - 2 x2^2))			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2
    (2) integration radius r, max. order of derivative n		*/
/************************************************************************/
#define MAIN
#include <mathC.h>


static complex_d f(const Vector<complex_d>& z, void *u);


int main() {
  int i, m, n;
  double r;
  Vector<double> x(2);

  x.read(stdin, "%lf");
  scanf("%lf%d", &r, &n);
  for (i = 0, m = 1; i <= n; i++) {
    try {
      Vector<double> y(m);
      y = diff_cauchy_all(f, NULL, i, x, r, 1.0e-9);
      printf("f[%d](x) = ", i);
      y.print(stdout, "", " %14.7e", "\n");
    }
    catch (MthException& e) {
      printf("error: %s\n", e.message());
      break;
    }
  }
  return mth_GOOD;
}

/************************************************************************/
/* argument function							*/
/*======================================================================*/
/* z		(i)  argument
   RESULT	(o)  exp(-z_1^2 - 2 z_2^2)				*/
/************************************************************************/
static complex_d f(const Vector<complex_d>& z, void *u) {
  return exp(-sq(z[0]) - 2.0 * sq(z[1]));
}
