/************************************************************************/
/* test_cy2: test differentiation subroutine diff_cauchy_all		*/
/* (calculation of derivatives of x1^2 + 2 x1 x2^2 + 4 x1 x2 x3^4	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2, x3
    (2) integration radius r, max. order of derivative n		*/
/************************************************************************/
#define MAIN
#include <mathC.h>


static complex_d f(const Vector<complex_d>& z, void *u);


int main() {
  int i, m, n;
  double r;
  Vector<double> x(3);

  x.read(stdin, "%lf");
  scanf("%lf%d", &r, &n);
  for (i = 0, m = 1; i <= n; i++) {
    try {
      Vector<double> y(m);
      y = diff_cauchy_all(f, NULL, i, x, r, 1.0e-9);
      printf("f[%d](x) = ", i);
      y.print(stdout, "", " %14.7e", "\n");
    }
    catch (MthException& e) {
      printf("error: %s\n", e.message());
      break;
    }
  }
  return mth_GOOD;
}

/************************************************************************/
/* argument function							*/
/*======================================================================*/
/* z		(i)  argument
   RESULT	(o)  z1^2 + 2 z1 z2^2 + 4 z1 z2 z3^4			*/
/************************************************************************/
static complex_d f(const Vector<complex_d>& z, void *u) {
  return z[0] * (z[0] + 2.0 * sq(z[1]) + 4.0 * z[1] * sq(sq(z[2])));
}
