/************************************************************************/
/* test_cy3: test differentiation subroutine diff_cauchy		*/
/* (calculation of derivatives of exp(-x1^2 - 2 x2^2))			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2
    (2) integration radius r, max. order of derivative n
    (3) direction vector						*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, n;
  double y, r;
  Vector<double> x(2), dir(2);

  x.read(stdin, "%lf");
  scanf("%lf%d", &r, &n);
  dir.read(stdin, "%lf");
  for (i = 0; i <= n; i++) {
    try {
      y = diff_cauchy([](const Vector<complex_d>& z) -> complex_d {
	return exp(-sq(z[0]) - 2.0 * sq(z[1]));
      }, i, dir, x, r, 1.0e-9);
      printf("f[%d](x) = %14.7e\n", i, y);
    }
    catch (MthException& e) {
      printf("error: %s\n", e.message());
      break;
    }
  }
  return mth_GOOD;
}
