/*************************************************************01.05.2015*/
/* test_G: test diff_gradient (n-dimensional 1st order differentiation)	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. x, y, z, increment, r (degree of extrapolation)

   result: derivatives of x^2 + 2 y^2 + 3 z^2 or exp(x + 2y + 3z)	*/
/************************************************************************/
#define MAIN
#include <mathC.h>

using namespace std;


int main() {
  int r;
  double h;
  Vector<double> x(3), dx(3), a(3);

  scanf("%lf%lf%lf%lf%d", &x[0], &x[1], &x[2], &h, &r);
  dx = h;
  try {
    a = diff_gradient([](const Vector<double>& x) -> double {
#if 0
      return sq(x[0]) + sq(x[1]) + sq(x[2]);
#else
      return exp(x[0] + 2.0 * x[1] + 3.0 * x[2]);
#endif
    }, x, r, dx);
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
    return mth_FAIL;
  }
  a.print(stdout, "", "%20.12e", "\n");
  return mth_GOOD;
}
