/*************************************************************27.05.2009*/
/* test_H: test diff_hessian (n-dimensional 2nd order differentiation)	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. x, y, z, increment, r (degree of extrapolation)

   result: derivatives of x^2 + 2 y^2 + 3 z^2 or exp(x + 2y + 3z)	*/
/************************************************************************/
#define MAIN
#include <mathC.h>

using namespace std;


int main() {
  int r, i;
  double h;
  Vector<double> x(3), dx(3);
  Matrix<double> a(3, 3);

  scanf("%lf%lf%lf%lf%d", &x[0], &x[1], &x[2], &h, &r);
  dx = h;
  try {
    a = diff_hessian([](const Vector<double>& x) -> double {
#if 0
      return sq(x[0]) + sq(x[1]) + sq(x[2]);
#else
      return exp(x[0] + 2 * x[1] + 3 * x[2]);
#endif
    }, x, r, dx);
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
    return mth_FAIL;
  }
  for (i = 0; i <= 2; i++) a[i].print(stdout, "", "%20.12e", "\n");
  return mth_GOOD;
}
