/************************************************************************/
/* test_lm2: test differentiation subroutine diff_lm			*/
/* (calculation of derivatives of exp(-x1^2 - 2 x2^2))			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2
    (2) integration radius r, max. order of derivative n
    (3) direction vector						*/
/************************************************************************/
#define MAIN
#include <mathC.h>


static double f(const Vector<complex_d>& z, void *u);


int main() {
  int i, n;
  double y, r;
  Vector<double> x(2), dir(2);

  x.read(stdin, "%lf");
  scanf("%lf%d", &r, &n);
  dir.read(stdin, "%lf");
  for (i = 1; i <= n; i++) {
    try {
      y = diff_lm(f, NULL, i, dir, x, r, -1.0e-10);
      printf("f[%d](x) = %15.8e\n", i, y);
    }
    catch (MthException& e) {
      printf("error: %s\n", e.message());
      break;
    }
  }
  return mth_GOOD;
}

/************************************************************************/
/* argument function							*/
/*======================================================================*/
/* z		(i)  argument
   RESULT	(o)  exp(-z_1^2 - 2 z_2^2)				*/
/************************************************************************/
static double f(const Vector<complex_d>& z, void *u) {
  return std::real(exp(-sq(z[0]) - 2.0 * sq(z[1])));
}
