/************************************************************************/
/* test_lm3: test differentiation subroutine diff_lm			*/
/* (calculation of derivatives of exp(-x1^2 - 2 x2^2))			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2
    (2) integration radius r						*/
/************************************************************************/
#define MAIN
#include <mathC.h>

using namespace std;


int main() {
  int i, m;
  double r;
  Vector<double> x(2);

  x.read(stdin, "%lf");
  scanf("%lf", &r);
  for (i = 1, m = 1; i <= 3; i++) {
    try {
      Vector<double> y(m);
      y = diff_lm_all([](const Vector<complex_d>& z) -> double {
	return real(exp(-sq(z[0]) - 2.0 * sq(z[1])));
      }, i, x, r, -1.0e-10);
      printf("f[%d](x) = ", i);
      y.print(stdout, " %15.8e");
      printf("\n");
    }
    catch (MthException& e) {
      printf("error: %s\n", e.message());
      break;
    }
  }
  return mth_GOOD;
}
