/************************************************************************/
/* test_mcx2: test differentiation subroutine diff_mcx(vector)		*/
/* (calculation of derivatives of exp(-x1^2 - 2 x2^2))			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2
    (2) direction vector						*/
/************************************************************************/
#define MAIN
#include <mathC.h>

using namespace std;


static multicomplex f(const Vector<multicomplex>& z, void *u);


int main() {
  double y;
  Vector<double> x(2), dir(2);

  fprintf(stderr, "2 arguments:\n");
  x.read(stdin, "%lf");
  fprintf(stderr, "direction vector:\n");
  dir.read(stdin, "%lf");
  try {
    y = diff_mcx(f, NULL, 1, dir, x);
    printf("f{%d}(x) = %15.8e\n", 1, y);
    y = diff_mcx(f, NULL, 2, dir, x);
    printf("f{%d}(x) = %15.8e\n", 2, y);
    y = diff_mcx(f, NULL, 3, dir, x);
    printf("f{%d}(x) = %15.8e\n", 3, y);
    y = diff_mcx(f, NULL, 4, dir, x);
    printf("f{%d}(x) = %15.8e\n", 4, y);
    y = diff_mcx(f, NULL, 5, dir, x);
    printf("f{%d}(x) = %15.8e\n", 5, y);
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
  }
  return mth_GOOD;
}

/************************************************************************/
/* argument function							*/
/*======================================================================*/
/* z		(i)  argument
   RESULT	(o)  exp(-z_1^2 - 2 z_2^2)				*/
/************************************************************************/
static multicomplex f(const Vector<multicomplex>& z, void *u) {
  return exp(-sq(z[0]) - 2.0 * sq(z[1]));
}
