/************************************************************************/
/* test_mcx3: test differentiation subroutine diff_mcx_all		*/
/* (calculation of derivatives of exp(-x1^2 - 2 x2^2))			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2						 */
/************************************************************************/
#define MAIN
#include <mathC.h>

using namespace std;


static multicomplex f(const Vector<multicomplex>& z, void *u);


int main() {
  double y;
  Vector<double> x(2);
  Vector<unsigned int> ord(2);

  x.read(stdin, "%lf");
  try {
    printf("f[%d](x) = ", 1);
    ord[0] = 1;
    ord[1] = 0;
    y = diff_mcx(f, NULL, ord, x);
    printf(" %15.8e", y);
    ord[0] = 0;
    ord[1] = 1;
    y = diff_mcx(f, NULL, ord, x);
    printf(" %15.8e", y);
    printf("\n");

    printf("f[%d](x) = ", 2);
    ord[0] = 2;
    ord[1] = 0;
    y = diff_mcx(f, NULL, ord, x);
    printf(" %15.8e", y);
    ord[0] = 1;
    ord[1] = 1;
    y = diff_mcx(f, NULL, ord, x);
    printf(" %15.8e", y);
    ord[0] = 0;
    ord[1] = 2;
    y = diff_mcx(f, NULL, ord, x);
    printf(" %15.8e", y);
    printf("\n");
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
    mth_FAIL;
  }
  return mth_GOOD;
}

static multicomplex f(const Vector<multicomplex>& z, void *u) {
  return exp(-sq(z[0]) - 2.0 * sq(z[1]));
}
