/************************************************************************/
/* test_mcx5: concrete tests of multicomplex derivatives		*/
/*	      contributed by Ian H. Bell				*/
/************************************************************************/
#define MAIN
#include <mathC.h>

static multicomplex f(const Vector<multicomplex>& z, void *u) {
  return sin(z[0] * z[1]);
}

int main() {
  multicomplex a, b;
  const double h = 1.0e-100,
    x = 0.1;
  int i;
  double deriv_num, deriv_ana;
  unsigned int l;

  scanf("%d", &l);
  a.init(l);
  a = 0.0;
  a.r_idx(0, x);
  a.r_idx(1, h);

  // 1st derivative of x * sin(x) w.r.t. x
  for (i = 0; i < 1000000; i++) {
    deriv_num = (a * sin(a)).r_idx(1) / h;
    deriv_ana = sin(x) + x * cos(x);
  }
  printf("a: (%15.8e %15.8e error: %15.8e)\n", deriv_num, deriv_ana,
  deriv_ana - deriv_num);
  return mth_GOOD;
}
