/************************************************************************/
/* test_r2: test differentiation methdod diff_ridders, vector version	*/
/* (calculation of derivatives of exp(-x1^2 - 2 x2^2))			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2
    (2) increment dx, max. order of derivative n
    (3) direction vector						*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, n;
  double y, dx, dev;
  Vector<double> x(2), dir(2);

  x.read(stdin, "%lf");
  scanf("%lf%d", &dx, &n);
  dir.read(stdin, "%lf");
  for (i = 1; i <= n; i++) {
    try {
      y = diff_ridders([](const Vector<double>& z, void *u) -> double {
	return exp(-sq(z[0]) - 2.0 * sq(z[1]));
      }, NULL, i, dir, x, dx, dev);
      printf("f[%d](x) = %15.8e, %10.3e\n", i, y, dev);
    }
    catch (MthException& e) {
      printf("error: %s\n", e.message());
      break;
    }
  }
  return mth_GOOD;
}
