/*************************************************************02.01.2003*/
/* test_rbg: test diff_romberg (1-dimensional differentiation)		*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
     x, order, increment, r (degree of extrapolation)
     Note: x is here restricted to [0, inf]

   result: derivatives of exp(x)					*/
/************************************************************************/
#define MAIN
#include <mathC.h>


static double f(double x, void *s);


int main() {
  int r, o;
  double x, dx, d;

  scanf("%lf%d%lf%d", &x, &o, &dx, &r);
  try {
    d = diff_romberg(f, NULL, o, x, dx, r, 0.0, mth_high);
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
    return mth_FAIL;
  }
  printf("%20.12e %20.12e\n", d, exp(x));
  return mth_GOOD;
}

static double f(double x, void *s) {
  return exp(x);
}
