/************************************************************************/
/* test_st3: test differentiation subroutine diff_st_all		*/
/* (calculation of derivatives of exp(-x1^2 - 2 x2^2))			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1) arguments x1, x2						*/
/************************************************************************/
#define MAIN
#include <mathC.h>

using namespace std;


int main() {
  Vector<double> x(2), y(2);
  x.read(stdin, "%lf");
  try {
    y = diff_st_all([](const Vector<complex_d>& z) -> complex_d {
      return exp(-sq(z[0]) - 2.0 * sq(z[1]));
    }, x);
    y.print(stdout, "f[1](x) =", " %15.8e", "\n");
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
  }
  return mth_GOOD;
}
