/************************************************************************/
/* test_p3: test subroutine eqn_cubic (solutions of cubic equations)	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	number of repetitions
    (2)	polynomial coefficents a[0] ... a[3]				*/
/************************************************************************/
#define MAIN
#include <time.h>
#include <mathC.h>


int main() {
  int i, n, nrep, t;
  Polynomial<double> a(4);
  Vector<double> x(3);

  scanf("%d", &nrep);
  a.read(stdin, "%lf");
  t = clock();
  for (i = 0; i < nrep; i++) n = eqn_cubic(a, x);
  t = clock();
  for (i = 0; i < n; i++) printf("%15.8e %11.4e\n", x[i],
  a[0] + x[i] * (a[1] + x[i] * (a[2] + x[i] * a[3])));
  printf("CPU time: %d ms\n", t / 1000);
  return mth_GOOD;
}
