/************************************************************************/
/* test_rf: test subroutine eqn_regulafalsi (nonlinear 1D equation	*/
/*	    solver by applying it to cubic polynomials			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. 2 positive (!) initial values					*/
/************************************************************************/
#define MAIN
#include <mathC.h>


static double f(double x, void *s);


int main() {
  double x, xmin, ymin, xmax, ymax;

  scanf("%lf%lf", &xmin, &xmax);
  ymin = 1.0 - pow(xmin, -8.0);		// don't trip the exception here!
  ymax = 1.0 - pow(xmax, -8.0);
  try {
    x = eqn_regulafalsi(f, NULL, xmin, xmax, ymin, ymax, 1.0e-9);
    printf("using both initial values:  %e\n", x);
    x = eqn_regulafalsi(f, NULL, xmin, 10, 1.0e-9);
    printf("using th 1st initial value: %e\n", x);
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
    return mth_FAIL;
  }
  catch (...) {
    printf("error in object function\n");
    return mth_FAIL;
  }
  return mth_GOOD;
}

/************************************************************************/
/* f: object function defining the equation to solve			*/
/*    here: f(x) = 1 - x^-8						*/
/************************************************************************/
static double f(double x, void *s) {
  if (x >= 100.0 || x <= 0.0) throw MthException(MthException::range);
  return 1.0 - pow(x, -8.0);
}
