/************************************************************************/
/* test_stc: test subroutine eqn_steffensen (nonlinear 1D equation	*/
/*	     solver), complex version					*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. polynomial coefficents a[0] ... a[3]
   2. initial value (real and imaginary part)				*/
/************************************************************************/
#define MAIN
#include <mathC.h>

using namespace std;


int main() {
  double x, y, a[4];
  complex_d z;

  scanf("%lf%lf%lf%lf", &a[0], &a[1], &a[2], &a[3]);
  scanf("%lf%lf", &x, &y);
  z.real(x);
  z.imag(y);
  try {
    z = eqn_steffensen([&](complex_d z, void *s) -> complex_d {
      return pow(-((a[2] * z + a[1]) * z + a[0]) / a[3], 1.0 / 3.0);
    }, NULL, z, 20, 1.0e-9);
  }
  catch (MthException &e) {
    printf("error: %s\n", e.message());
    return mth_FAIL;
  }
  printf("z = (%14.7e, %14.7e)\n", z);
  return mth_GOOD;
}
