/************************************************************************/
/* test_ptr: test integration subroutine int_ptrapez			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout
  
   stdin sequence: -							*/
/************************************************************************/
#define MAIN
#include <mathC.h>


static double f(double x, void *u);


int main() {
  double q, qex;

  try {
    q = int_ptrapez(f, NULL, 2.0 * mth_pi, -mth_eps0);
  }
  catch (...) {
    printf("exception!\n");
    return mth_FAIL;
  }
  qex = mth_pi;
  printf("int_ptrapez: %f   exact: %f\n", q, qex);
  return mth_GOOD;
}

/************************************************************************/
/* integrand function							*/
/*======================================================================*/
/* x		(i)  argument
   RESULT	(o)  exp(x)						*/
/************************************************************************/
static double f(double x, void *u) {
  return sq(sin(x)) + cos(4 * x);
}
