/************************************************************************/
/* test_rbg: test integration subroutine int_romberg			*/
/* (calculation of Integral(exp(x) dx))					*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
     Enter integration limits a and b, and the desired precision.	*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  double a, b, q, qex, eps;

  scanf("%lf%lf%d", &a, &b, &eps);
  try {
    q = int_romberg([](double x) -> double {
      return exp(x);
    }, a, b, eps);
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
    return mth_FAIL;
  }
  qex = exp(b) - exp(a);
  printf("int_romberg: %f   exact: %f\n", q, qex);
  return mth_GOOD;
}
