/*************************************************************02.01.2003*/
/* test_lgd: test ipl_lagrange (Lagrange interpolation)		*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	number of points
    (2)	for each point: x, y

   stdout: coefficients of Lagrange polynomial				*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, n;

  scanf("%d", &n);
  Polynomial<double> a(n);
  Vector<double> x(n), y(n);

  for (i = 0; i < n; i++) scanf("%lf%lf", &x[i], &y[i]);
  try {
    a = ipl_lagrange(x, y);
  }
  catch (MthException &e) {
    printf("error: %s\n", e.message());
    return mth_FAIL;
  }
  
  for (i = 0; i < n; i++) printf("%3d %e\n", i, a[i]);
  return mth_GOOD;
}
