/************************************************************************/
/* test_sspl: test ipl_reinsch (smoothing spline interpolation)		*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	n, number of data points
    (2)	for each point: x, y, y-uncertainty (x in increasing order!)
    (3) s parameter (typically about n)
    (4)	x value for interpolation
    (5)	go to (4); NAN or CTRL-d terminate				*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, n;
  double xarg, yarg, s;

  scanf("%d", &n);
  SortedVector<double> x(n);
  Vector<double> y(n), yc(n), dy(n);
  Matrix<double> c(3, n);

  for (i = 0; i < n; i++) scanf("%lf%lf%lf", &x[i], &y[i], &dy[i]);
  scanf("%lf", &s);
  try {
    ipl_reinsch(x, y, dy, s, yc, c);
  }
  catch (MthException &e) {
    printf("caught exception: %s\n", e.message());
    return mth_FAIL;
  }
  for (i = 0; i < n; i++)
  printf("%2d %13.6e %13.6e %13.6e %13.6e %13.6e %13.6e\n", i, x[i],
  y[i], yc[i], c[0][i], c[1][i], c[2][i]);
  printf("\n");
  while ((i = scanf("%lf", &xarg)) == 1) {
    yarg = ipl_eval(xarg, x, yc, c, 0);
    printf("%13.6e %13.6e\n", xarg, yarg);
  }
  return mth_GOOD;
}
