/************************************************************************/
/* test_spl: test ipl_spline or ipl_akima (interpolation methods)	*/
/*	     (use -DAKIMA compiler option to choose)			*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	number of data points
    (2)	for each point: x, y (x in increasing order!)
    (3)	x value for interpolation
    (4) go to (3); NAN or CTRL-d terminate				*/
/************************************************************************/
#define MAIN
#include <mathC.h>

int main() {
  int i, n;
  double xarg, yarg;

  scanf("%d", &n);

  SortedVector<double> x(n);
  Vector<double> y(n);
  Matrix<double> c(3, n);

  for (i = 0; i < n; i++) scanf("%lf%lf", &x[i], &y[i]);
  try {
#ifdef AKIMA
    ipl_akima(x, y, c);
#else
    ipl_spline(x, y, c);
#endif
  }
  catch (MthException &e) {
    printf("caught exception: %s\n", e.message());
    return mth_FAIL;
  }
  printf("%d\n", n);
  for (i = 0; i < n; i++) printf("%13.6e %13.6e %13.6e %13.6e %13.6e\n",
  x[i], y[i], c[0][i], c[1][i], c[2][i]);
  printf("\n");
  while ((i = scanf("%lf", &xarg)) == 1) {
    yarg = ipl_eval(xarg, x, y, c, 0);
    printf("%13.6e %13.6e\n", xarg, yarg);
  }
  return mth_GOOD;
}
