/************************************************************************/
/* test_spl_i: same as test_spline, except that the initial and/or	*/
/*	       final slope of the spline function can be kept fixed	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout
   stderr

   stdin:
    (1)	flag (2 * j + i: i = initial slope fixed, j = final slope fixed) 
    (2)	if flag > 0: initial slope(s)
    (3)	number of data points
    (4)	for each point: x, y (x in increasing order!)
    (5)	x value for interpolation
    (6) go to (5); NAN or CTRL-d terminate				*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, n, flag;
  double xarg, yarg, sinit, sfinal;

  scanf("%d", &flag);
  if (flag & 0x01) scanf("%lf", &sinit);
  if (flag & 0x02) scanf("%lf", &sfinal);
  scanf("%d", &n);

  SortedVector<double> x(n);
  Vector<double> y(n);
  Matrix<double> c(3, n);

  for (i = 0; i < n; i++) scanf("%lf%lf", &x[i], &y[i]);
  try {
    if (flag & 0x01) c[0][0] = sinit;
    if (flag & 0x02) c[0][n - 1] = sfinal;
    ipl_spline(x, y, flag, c);
  }
  catch (MthException &e) {
    printf("caught exception: %s\n", e.message());
    return mth_FAIL;
  }
  printf("%d\n", n);
  for (i = 0; i < n; i++) printf("%13.6e %13.6e %13.6e %13.6e %13.6e\n",
  x[i], y[i], c[0][i], c[1][i], c[2][i]);
  printf("\n");
  while ((i = scanf("%lf", &xarg)) == 1) {
    yarg = ipl_eval(xarg, x, y, c, 0);
    printf("%13.6e %13.6e\n", xarg, yarg);
  }
  return mth_GOOD;
}
