/************************************************************************/
/* test_gs: test lin_gauss (solver for systems of linear equations)	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	number of unknowns n
    (2)	n times: n coefficients, r.h.s. value				*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, n;

  scanf("%d", &n);
  Matrix<double> a(n, n);
  Vector<double> b(n), x(n);

  for (i = 0; i < n; i++) {
    a[i].read(stdin, "%lf");
    scanf("%lf", &b[i]);
  }
  try {
    x = lin_gauss(a, b);
  }
  catch (MthException &e) {
    printf("error: %s\n", e.message());
    return mth_FAIL;
  }
  x.print(stdout, "%14.6e");
  printf("\n");
  return mth_GOOD;
}
