/************************************************************************/
/* test_jcb: test lin_jacobi (eigenvalues of a symmetric matrix)	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	number of rows n
    (2)	for each row: n matrix elements (symmetric!!!)			*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, k, n;

  scanf("%d", &n);
  Matrix<double> a(n, n), v(n, n);
  Vector<double> d(n);

  for (i = 0; i < n; i++) a[i].read(stdin, "%lf");
  lin_jacobi(a, d, v);
  for (i = 0; i < n; i++) {
    printf("%8.4f -> ", d[i]);
    v[i].print(stdout, "%8.4f");
    printf("\n");
  }

  printf("\nproof: matrix * eigenvector[i] / eigenvalue[i]\n");
  Vector<double> r(n);
  for (i = 0; i < n; i++) {
    r = a * v[i];
    printf("%d:", i);
    for (k = 0; k < n; k++) printf("%8.4f", r[k] / d[i]);
    printf("\n");
  }
  return mth_GOOD;
}
