/************************************************************************/
/* test_inv: test lin_matinv() matrix inversion subroutine		*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	number of rows n
    (2)	for each row: n matrix elements					*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, n;

  scanf("%d", &n);
  Matrix<double> a(n, n), b(n, n), c(n, n);

  for (i = 0; i < n; i++) a[i].read(stdin, "%lf");
  b = a;
  try {
    lin_matinv(a);
  }
  catch (MthException& e) {
    printf("error %s\n", e.message());
    return mth_FAIL;
  }
  for (i = 0; i < n; i++) {
    a[i].print(stdout, "%8.4f");
    printf("\n");
  }
  printf("\n");
  c = a * b;
  for (i = 0; i < n; i++) {
    c[i].print(stdout, "%8.4f");
    printf("\n");
  }
  return mth_GOOD;
}
