/************************************************************************/
/* test_ray: test lin_rayleigh (lowermost eigenvalue of a symmetric	*/
/* matrix)								*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	number of rows n
    (2)	for each row: n matrix elements (symmetric!!!)
    (3) estimate for an eigenvalue					*/
/************************************************************************/
#define MAIN
#include <mathC.h>


int main() {
  int i, k, n;
  double e;

  scanf("%d", &n);
  Matrix<double> a(n, n);
  Vector<double> u(n);

  for (i = 0; i < n; i++) a[i].read(stdin, "%lf");
  scanf("%lf", &e);
  lin_rayleigh(a, e, u);
  printf("%8.4f -> ", e);
  u.print(stdout, "%8.4f");
  printf("\n");

  printf("\nproof: matrix * eigenvector / eigenvalue\n");
  Vector<double> r(n);
  r = a * u;
  for (k = 0; k < n; k++) printf("%8.4f", r[k] / e);
  printf("\n");
  return mth_GOOD;
}
