/************************************************************************/
/* test_descent: test the performance of the steepest-descent minimizer	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin:
    (1)	test function parameters: x1_min, x2_min, k1, k2
    (2)	start values: x1, x2						*/
/************************************************************************/
#define MAIN
#include <mathC.h>


struct exp_data {
  double x0[2], k[2];
};


static double f(const Vector<double>& x, void *uv);


int main() {
  double h;
  struct exp_data d;
  Vector<double> x(2);

  scanf("%lf%lf%lf%lf", &d.x0[0], &d.x0[1], &d.k[0], &d.k[1]);
  x.read(stdin, "%lf");
  try {
    h = min_descent(f, x, &d, 100, 1);
  }
  catch (MthException& e) {
    printf("error: %s\n", e.message());
  }
  x.print(stdout, "minimum at", " %12.5e", "\n");
  printf("y = %12.5e\n", h);
  return mth_GOOD;
}

static double f(const Vector<double>& x, void *uv) {
  struct exp_data& u = *static_cast<struct exp_data *>(uv);
  return u.k[0] * sq(x[0] - u.x0[0]) + u.k[1] * sq(x[1] - u.x0[1]);
}
