/****************************************************************/
/* test_lf2: lattice filling test of a random number generator	*/
/*	     2-dimensional					*/
/*==============================================================*/
/* I/O channels:
   stdout: number of steps and fraction of free sites		*/
/****************************************************************/
#define MAIN
#include <mathC.h>


/* random number generators */
// #define RANDOM		(rand() * nsize) / RAND_MAX
// #define RANDOM		nsize * ran_shuffle()
// #define RANDOM		nsize * ran_cgr48()
// #define RANDOM		nsize * ran_stauffer()
// #define RANDOM		nsize * ran_ecuyer()
// #define RANDOM		nsize * ran_test()
#define RANDOM		nsize * ran_mt()

double ran_test() throw ();

const int
  nsize = 128,				// lattice size
  nx = nsize - 1,
  maxtry = 100000,			// max. number of trials
  nreport = 100;


int main() {
  int i, j, k, free, step,
    total = sq(nsize);
  char s[nsize][nsize], *p;
  double quota;

  free = total;				// initialize
  for (i = 0, p = &s[0][0]; i < total; i++, p++) *p = '\0';

  for (step = 0; step < maxtry; step++) {// main test loop
    i = RANDOM;
    j = RANDOM;
    p = &s[i][j];
    if (*p == '\0') {
      *p = '\1';
      free--;
    }
    if (step % nreport == 0) {
      quota = ((double) free)/((double) total);
      printf("%5d %f\n", step / nreport, quota);
    }
  }
  return mth_GOOD;
}

/*************************************************************10.12.2001*/
/* ran_stauffer: Stauffer's random number generator			*/
/*									*/
/* D. Stauffer, U. Cologne proposed a simple, but good multiplicative 	*/
/* algorithm:								*/
/* x[i+1] = (a*x[i]) mod m						*/
/* with: a = 16807, m = 2^31						*/
/************************************************************************/
#include <time.h>

using namespace std;


double ran_test() throw () {
  static int i, linit = 0;
  static double norm;

  if (linit == 0) {			// initialization
    linit = 1;
    i = time(NULL);			// get seconds after 1900
    if (i % 2 == 0) i--;
    if (i % 3 == 0) i -= 2;
    norm = pow(2.0, -32.0);		// normalization constant
  }

  /* The next instruction works only if there is no overflow check. */
//i *= 16807;
  i *= 49;
  return 0.5 + i * norm;
}
