/****************************************************************/
/* test_lf3: lattice filling test of a random number generator	*/
/*	     3-dimensional					*/
/*==============================================================*/
/* I/O channels:
   stdout: number of steps and fraction of free sites		*/
/****************************************************************/
#define MAIN
#include <mathC.h>


/* random number generators */
// #define RANDOM		(rand() * nsize) / RAND_MAX
#define RANDOM		nsize * ran_shuffle()
// #define RANDOM		nsize * ran_cgr48()
// #define RANDOM		nsize * ran_stauffer()
// #define RANDOM		nsize * ran_ecuyer()
// #define RANDOM		nsize * ran_mt()


const int
  nsize = 128,				// lattice size
  nx = nsize - 1,
  maxtry = 10000000,			// max. number of trials
  nreport = 10000;


int main() {
  int i, j, k, free, step,
    total = cb(nsize);
  char s[nsize][nsize][nsize], *p;
  double quota;

  free = total;				// initialize
  for (i = 0, p = &s[0][0][0]; i < total; i++, p++) *p = '\0';

  for (step = 0; step < maxtry; step++) {// main test loop
    i = RANDOM;
    j = RANDOM;
    k = RANDOM;
    p = &s[i][j][k];
    if (*p == '\0') {
      *p = '\1';
      free--;
    }
    if (step % nreport == 0) {
      quota = ((double) free)/((double) total);
      printf("%5d %f\n", step / nreport, quota);
    }
  }
  return mth_GOOD;
}
