/*************************************************************17.04.2003*/
/* ipl_peval: evaluation of the periodic spline function defined by	*/
/*	      ipl_pspline						*/
/*======================================================================*/
/* xvalue	(i)  abszissa value
   x[n], y[n]	(i)  abszissa and ordinate arrays
   b, c, d[n]	(i)  coefficient arrays generated by ipl_spline()
   k		(i)  order of derivative (0 <= k <= 2)
   RESULT	(o)  value of splien function				*/
/************************************************************************/
#include <math.h>
#include <mathc.h>

double ipl_peval(double xvalue, int n, double *x, double *y, double *b,
double *c, double *d, int k) {
  int i, high, low;
  double xx, yvalue, period;

  if (xvalue < x[0] || xvalue > x[n - 1]) {
    period = x[n - 1] - x[0];
    i = (xvalue - x[0]) / period;
    xvalue -= i * period;
  }
  low = 0;				/* locate interval by bisection */
  high = n - 1;
  while (high - low > 1) {
    i = (low + high) / 2;
    if (xvalue >= x[i])
      low = i;
    else
      high = i;
  }
  xx = xvalue - x[low];
  switch (k) {
  case 0:
    yvalue = ((d[low] * xx + c[low]) * xx + b[low]) * xx + y[low];
    break;
  case 1:
    yvalue = (3 * d[low] * xx + 2 * c[low]) * xx + b[low];
    break;
  case 2:
    yvalue = 6 * d[low] * xx + 2 * c[low];
    break;
  case 3:
    yvalue = 6 * d[low];
    break;
  default:
    yvalue = 0.0;
  }
  return (yvalue);
}
