/*************************************************************09.10.2005*/
/* old: dummy functions, links, etc., which ensure that older programs	*/
/*	are compatible with this version of the math library		*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>

struct pass2 {				/* for regula_falsi */
  double (*f)();
  void *s;
};


int akima(int n, double *x, double *y, double *b, double *c, double *d) {
  return (ipl_akima(n, x, y, b, c, d));
}

int cubic(const double *a, double *x) {
  return (eqn_cubic(a, x));
}

int deriv1(double (*f)(), int n, double x, double h, double *fd,
double *err) {
  return (diff_ridders(f, NULL, n, x, h, fd, err));
}

int deriv2all(double (*f)(), double x, double y, void *s, int n, int r,
double dx, double dy, double *deriv) {
  return (diff_2all(f, x, y, s, n, r, dx, dy, deriv));
}
double intgauss(double (*f)(), int k, double a, double b, int n) {
  return (int_gauss(f, NULL, k, a, b, n));
}

double intsimpson(double (*f)(), double a, double b, int n) {
  return (int_simpson(f, NULL, a, b, n));
}

int intromberg(double (*f)(), double a, double b, double eps, int maxord,
double *q) {
  return (int_romberg(f, NULL, a, b, eps, maxord, q));
}

int marqua(int (*f)(), int m, double *x, int n, void *aux, int maxit,
int iprot, double *ynorm) {
  return (fit_marquardt(f, m, x, n, aux, maxit, iprot, ynorm));
}

int minimum(double (*f)(), void *s, double a, double b, double step,
double eps, double *xmin, double *ymin) {
  return (minimum1(f, s, a, b, step, eps, xmin, ymin));
}

int powell(int (*obj)(), int m, double *x, int n, void *aux, int maxit,
int iprot, double *rms) {
  return (fit_powell(obj, m, x, n, aux, maxit, iprot, rms));
}

int quadratic(const double *a, double *x) {
  return (eqn_quadratic(a, x));
}

int quartic(const double *a, double *x) {
  return (eqn_quartic(a, x));
}

int quintic(const double *a, double *x) {
  return (eqn_quintic(a, x));
}

double ran2_ecu(void) {
  return (ran_ecuyer());
}

double ran_st(void) {
  return (ran_stauffer());
}

void ranvector(double (*random)(), int n, double *u) {
  ran_vector(random, n, u);
}

double regfalsi(double (*f)(), void *s, double xa, double xb, double ya,
double yb, double eps) {
  return (regula_falsi(f, s, xa, xb, ya, yb, eps));
}

int spline(int n, double *x, double *y, double *b, double *c, double *d) {
  return (ipl_spline(n, x, y, b, c, d));
}

double spval(double xvalue, int n, double *x, double *y, double *b,
double *c, double *d) {
  return (ipl_eval(xvalue, n, x, y, b, c, d, 0));
}

int steff1(double (*f)(), double *x, int kmax, double eps) {
  return (eqn_steffensen(f, NULL, x, kmax, eps));
}

static int obj_rf(double x, struct pass2 *s, double *y) {
  *y = s->f(x, s->s);
  return (MTH_GOOD);
}

double regula_falsi(double (*f)(), void *s, double xa, double xb, double ya,
double yb, double eps) {
  double x;
  struct pass2 ss;

  ss.f = f;
  ss.s = s;
  eqn_regulafalsi(obj_rf, &ss, xa, xb, ya, yb, eps, &x);
  return (x);
}
