/*************************************************************10.12.2001*/
/* ran_stauffer: Stauffer's random number generator			*/
/*									*/
/* D. Stauffer, U. Cologne proposed a simple, but good multiplicative 	*/
/* algorithm:								*/
/* x[i+1] = (a*x[i]) mod m						*/
/* with: a = 16807, m = 2^31						*/
/************************************************************************/
#include <time.h>
#include <math.h>
#include <mathc.h>

double ran_stauffer(void) {
  static int i, linit = 0;
  static double norm;

  if (linit == 0) {			/* initialization */
    linit = 1;
    i = time(NULL);			/* get seconds after 1900 */
    if (i % 2 == 0) i--;
    if (i % 3 == 0) i -= 2;
    norm = pow(2.0, -32.0);		/* normalization constant */
  }

  /* The next instruction works only if there is no overflow check */
  i *= 16807;
  return (0.5 + i * norm);
}
