/*************************************************************12.12.2001*/
/* ran_vector: unit vector with random orientation			*/
/*	       (Jansoone's method)					*/
/*======================================================================*/
/* random()	(i)  uniform random number generator ( r = random() )
   n		(i)  vector dimensionality
   u		(io) unit vector					*/
/************************************************************************/
#include <math.h>
#include <mathc.h>

void ran_vector(double (*random)(), int n, double *u) {
  double *p, *pmax, s;

  pmax = u + n - 1;
  do {
    s = 0.0;
    p = u;
    while (p <= pmax) {			/* random vector in cube [-1; +1] */
      *p = 2 * (*random)() - 1.0;
      s += SQ(*p);
      p++;
    }
  } while (s <= 0.0 || s > 1.0);	/* discard vectors outside sphere */
  s = 1.0 / sqrt(s);
  p = u;
  while (p <= pmax) *p++ *= s;		/* normalize */
}
