/*************************************************************16.12.2001*/
/* test1: test diff_2all (2-dimensional differentiation)		*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. x, y, increment, r (degree of extrapolation, 0 <= r <= 2)

   result: derivatives of exp(x) * exp(y)				*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>


static double f(double x, double y, void *s);


int main(void) {
  int i, r;
  double x, y, dx, dy, dinc, d[15];

  scanf("%lf%lf%lf%d", &x, &y, &dinc, &r);
  dx = x * dinc;
  dy = y * dinc;
  if ((i = diff_2all(f, x, y, NULL, 4, r, dx, dy, d)) != 0) {
    printf("error %d\n");
    return (MTH_FAIL);
  }
  
  for (i = 0; i < 15; i++) printf("%20.12e\n", d[i]);
  printf("\n%20.12e\n", exp(x + y));
  return (MTH_GOOD);
}

static double f(double x, double y, void *s) {
  return (exp(x + y));
}
