/*************************************************************02.01.2003*/
/* test1: test diff_romberg (1-dimensional differentiation)		*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. x, increment, xmin, xmax, r (degree of extrapolation)

   result: derivatives of exp(x)					*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>


static double f(double x, void *s);


int main(void) {
  int i, r;
  double x, dx, xmin, xmax, d;

  scanf("%lf%lf%lf%lf%d", &x, &dx, &xmin, &xmax, &r);
  if ((i = diff_romberg(f, NULL, 1, x, dx, r, xmin, xmax, &d)) != 0) {
    printf("error %d\n");
    return (MTH_FAIL);
  }
  printf("%20.12e %20.12e\n", d, exp(x));
  return (MTH_GOOD);
}

static double f(double x, void *s) {
  return (exp(x));
}
