/************************************************************************/
/* test2: test dmatrix_invert.c matrix inversion subroutine		*/
/*======================================================================*/
/* I/O channels
   stdin
   stdout

   required input:
   1. matrix number of rows n
   2. n times a row consisting of n numbers				*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>


int main(void) {
  int i, k, n;
  dmatrix a, b, c;

  scanf("%d", &n);
  if (dmatrix_create(&a, 0, n - 1, 0, n - 1) != 0
  || dmatrix_create(&b, 0, n - 1, 0, n - 1) != 0
  || dmatrix_create(&c, 0, n - 1, 0, n - 1) != 0) {
    printf("too big!\n");
    return (MTH_NOMEM);
  }
  for (i = 0; i < n; i++) {
    for (k = 0; k < n; k++) {
      scanf("%lf", &a.a[i][k]);
      b.a[i][k] = a.a[i][k];
    }
  }
  i = dmatrix_invert(&a);
  printf("error code: %d\n", i);
  for (i = 0; i < n; i++) {
    for (k = 0; k < n; k++) printf("%8.4lf", a.a[i][k]);
    printf("\n");
  }
  printf("\n");
  dmatrix_mul(&a, &b, &c);
  for (i = 0; i < n; i++) {
    for (k = 0; k < n; k++) printf("%8.4lf", c.a[i][k]);
    printf("\n");
  }
  return (MTH_GOOD);
}
