/************************************************************************/
/* test2: test min_powell, the minimizer within fit_powell		*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. 3 initial values for amplitude, center, and width of Gaussian
   2. 5 data pairs							*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>


struct exp_data {
  int n;
  double t[5], u[5];
};


int f(double *x, double *y, struct exp_data *a);/* prototype of object func. */


int main(void) {
  int i;
  double x[3], ynorm, y[5];
  struct exp_data d;

  for (i = 0; i < 3; i++) scanf("%lf", &x[i]);
  for (i = 0; i < 5; i++) scanf("%lf%lf", &d.t[i], &d.u[i]);
  d.n = 5;
  i = min_powell(f, 3, x, &d, 50, 1, &ynorm);
  printf("\nerror code: %d   ymin: %e\n", i, ynorm);
  for (i = 0; i < 3; i++) printf("%lf ", x[i]);
  return (MTH_GOOD);
}

int f(double *x, double *y, struct exp_data *a) {
  int i;
  for (i = 0, *y = 0.0; i < 5; i++)
  *y += SQ(x[0] * exp(-SQ((a->t[i] - x[1]) / x[2])) - a->u[i]);
  return (MTH_GOOD);
}
