/************************************************************************/
/* test2: test integration subroutine int_romberg			*/
/* (calculation of Integral(exp(x) dx))					*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. Enter integration limits a and b, and the desired precision.	*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>


double function(double x, void *u);


int main(void) {
  int err;
  double a, b, q, qex, eps;

  scanf("%lf%lf%d", &a, &b, &eps);
  err = int_romberg(function, NULL, a, b, eps, 15, &q);
  qex = exp(b) - exp(a);
  printf("int_romberg: %d %lf   exact: %lf\n", err, q, qex);
  return (MTH_GOOD);
}

/**********************************************************************/
/* Integrand function: exp(x)					      */
/*====================================================================*/
/* x		   (i)	argument
   RESULT	   (o)  exp(x)					      */
/**********************************************************************/
double function(double x, void *u) {
  return (exp(x));
}
