/************************************************************************/
/* test1: test ipl_spline or ipl_akima (interpolation methods)		*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   stdin sequence:
   1. number of data pairs (max. 32)
   2. as many pairs (with increasing x-values)
   3. x increment foa a tabulation of the spline function		*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>


#define NDATA		32


int main(void) {
  int i, n;
  double h, xarg, yarg, x[NDATA], y[NDATA], b[NDATA], c[NDATA], d[NDATA];

  scanf("%d", &n);
  for (i = 0; i < n; i++) scanf("%lf%lf", &x[i], &y[i]);
  i = ipl_spline(n, x, y, b, c, d);
  printf("error code: %d\n\n", i);
  if (i > 0) return (i);
  for (i = 0; i < n; i++) printf("%2d %f %f %f %f %f\n", i, x[i],
  y[i], b[i], c[i], d[i]);
  printf("\n");
  scanf("%lf", &h);
  for (xarg = x[0]; xarg <= x[n - 1]; xarg += h) {
    yarg = ipl_eval(xarg, n, x, y, b, c, d, 0);
    printf("%f %f\n", xarg, yarg);
  }
  return (MTH_GOOD);
}
