/************************************************************************/
/* test1: test lin_jacobi (eigenvalues of a symmetric matrix)		*/
/*======================================================================*/
/* I/O channels
   stdin
   stdout

   required input:
   1. number of unknowns n
   2. n times a row consisting of n coefficients			*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>


int main() {
  int i, k, n, err;
  dmatrix a, v;
  dvector d;

  scanf("%d", &n);
  if (dmatrix_create(&a, 0, n - 1, 0, n - 1) != 0
  || dmatrix_create(&v, 0, n - 1, 0, n - 1) != 0
  || dvector_create(&d, 0, n - 1) != 0) {
    printf("memory allocation for a failed\n");
    return (MTH_NOMEM);
  }
  for (i = 0; i < n; i++) {
    for (k = 0; k < n; k++) scanf("%lf", &a.a[i][k]);
  }
  i = lin_jacobi(&a, &d, &v);
  printf("error code: %d\n", i);
  for (i = 0; i < n; i++) {
    printf("%8.4f -> ", d.a[i]);
    for (k = 0; k < n; k++) printf("%8.4f", v.a[k][i]);
    printf("\n");
  }
  return MTH_GOOD;
}
