/************************************************************************/
/* test1: test linsys_gauss (solver for systems of linear equations)	*/
/*======================================================================*/
/* I/O channels:
   stdin
   stdout

   required input:
   1. number of unknowns n
   2. n times a row consisting of n coefficients and the r.h.s. value	*/
/************************************************************************/
#include <stdio.h>
#include <math.h>
#include <mathc.h>


int main(void) {
  int i, k, n, err;
  dmatrix a;
  dvector b, x;

  scanf("%d", &n);
  if (dmatrix_create(&a, 0, n - 1, 0, n - 1) != 0 ||
  dvector_create(&b, 0, n - 1) != 0 || dvector_create(&x, 0, n - 1) != 0) {
    printf("memory allocation for a failed\n");
    return (MTH_NOMEM);
  }
  for (i = 0; i < n; i++) {
    for (k = 0; k < n; k++) scanf("%lf", &a.a[i][k]);
    scanf("%lf", &b.a[i]);
  }
  i = linsys_gauss(&a, &b, &x);
  printf("error code: %d\n", i);
  for (i = 0; i < n; i++) printf("%8.4lf", x.a[i]);
  printf("\n");
  return (MTH_GOOD);
}
