/****************************************************************/
/* test1: demonstrate properties of dynamic memory allocation	*/
/*==============================================================*/
/* I/O channels:
   stdout							*/
/****************************************************************/
#include <stdio.h>
#include <stdlib.h>

#define NSIZE		10000


void voidsub(int n);


int main(void) {
  char *p;

  p = (char *) malloc((size_t) (0));
  printf("\nbefore doing any allocations:\n");
  memorymap(1);

  p = (char *) malloc((size_t) (NSIZE));
  printf("\nafter allocation in main:\n");
  memorymap(1);

  voidsub(NSIZE);

  printf("\nafter returning from subroutine:\n");
  memorymap(1);

  free((void *) p);
  printf("\nafter freeing main allocation:\n");
  memorymap(1);

  return (0);
}

void voidsub(int n)
{
  char *q;

  q = (char *) malloc((size_t) (n));
  printf("\nafter allocation in subroutine:\n");
  memorymap(1);
}
