/****************************************************************/
/* test1: lattice filling test of a random number generator	*/
/*==============================================================*/
/* I/O channels:
   stdout: number of steps and fraction of free sites		*/
/****************************************************************/
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <math.h>
#include <mathc.h>

#define NSIZE		128		/* lattice size */
#define NX		NSIZE-1
#define MAXTRY		10000000	/* max. number of trials */
#define	NREPORT		10000

/* random number generators */
/* #define RANDOM		rand()/512	*/
#define RANDOM		NSIZE*ran_cgr48()
/* #define RANDOM		NSIZE*ran_st()	*/
/* #define RANDOM		NSIZE*ran2_ecu()*/

int main(void) {
  int i, j, k, free, step,
      total = CB(NSIZE);
  char s[NSIZE][NSIZE][NSIZE], *p;
  double quota;

  free = total;				/* initialize */
  for (i = 0, p = &s[0][0][0]; i < total; i++, p++) *p = '\0';
  srand48(3141593);

  for (step = 0; step < MAXTRY; step++) {/* main test loop */
    i = RANDOM;
    j = RANDOM;
    k = RANDOM;
    p = &s[i][j][k];
    if (*p == '\0') {
      *p = '\1';
      free--;
    }
    if (step%NREPORT == 0) {
      quota = ((double) free)/((double) total);
      printf("%d %f\n", step/NREPORT, quota);
    }
  }
  return (0);
}
